#!/usr/bin/env node
import u from "node:path";
import p from "node:fs";
import { log as i, json5 as F, chalk as $, xPrompts as N, createSubcommand as O, getRootScriptName as L, createMainCommand as T } from "@done-coding/cli-utils";
import E from "lodash.upperfirst";
import y from "lodash.camelcase";
import C from "lodash.kebabcase";
import _ from "lodash.lowerfirst";
import f from "lodash.template";
import { OutputModeEnum as v, compileHandler as S } from "@done-coding/cli-template";
var m = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(m || {});
const K = (e, t) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return i.error("组件名只能包含字母、数字、中划线"), process.exit(1);
  const { nameExcludes: n } = t;
  return n.includes(e) ? (i.error(`组件名: ${e}是保留名称。
保留名称: ${n.join(",")}`), process.exit(1)) : !0;
}, g = {
  name: "@done-coding/cli-component",
  version: "0.4.0-alpha.0",
  description: "组件命令行工具",
  bin: {
    "dc-component": "es/cli.mjs"
  },
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: J, moduleName: z } = g.cliConfig, P = () => u.resolve(J, z), I = () => ({
  execDir: process.cwd(),
  templateDir: P()
}), D = (e) => {
  const { series: t, name: n } = e, o = E(y(n)), a = _(o), s = C(o), c = t ? E(y(t)) : "", l = c ? `${c}${o}` : "", d = C(l);
  return {
    series: c,
    name: o,
    nameLowerFirst: a,
    nameKebab: s,
    fullName: l,
    fullNameKebab: d,
    cls: d
  };
}, Z = (e) => ({
  $: "$",
  ...I(),
  ...D(e)
}), h = () => {
  const e = u.resolve(P(), "index.json");
  if (!p.existsSync(e))
    return i.error(`模块入口文件不存在: ${e}`), process.exit(1);
  const n = JSON.parse(p.readFileSync(e, "utf-8")).config;
  if (!n)
    return i.error(`配置文件相对路径不存在: ${n}`), process.exit(1);
  const o = u.resolve(
    u.dirname(e),
    n
  );
  if (!p.existsSync(o))
    return i.error(`配置文件不存在: ${o}`), process.exit(1);
  const a = F.parse(p.readFileSync(o, "utf-8")), s = I();
  return a.componentDir = f(a.componentDir)(s), a;
}, R = async ({
  name: e,
  config: t,
  command: n
}) => {
  if (![m.ADD, m.REMOVE].includes(n))
    return i.error(`不支持组件${n}操作`), process.exit(1);
  const o = Z({
    ...t,
    name: e
  }), a = process.cwd(), s = JSON.stringify(o);
  for (const { entry: c, index: l } of t.list) {
    const d = {
      envData: s,
      rollback: n === m.REMOVE,
      /** 回滚时可以删除空文件 */
      rollbackDelNullFile: !0,
      rollbackDelAskAsYes: !0,
      dealMarkdown: !0,
      batch: !1,
      rootDir: a
    };
    if (c) {
      const r = c;
      r != null && r.input && (r.input = f(r.input)(o)), r != null && r.output && (r.output = f(r.output)(o));
      const b = {
        ...c,
        mode: v.APPEND,
        ...d
      };
      await S(b);
    }
    if (l) {
      const r = l;
      r != null && r.input && (r.input = f(r.input)(o)), r != null && r.output && (r.output = f(r.output)(o));
      const b = {
        ...l,
        mode: v.OVERWRITE,
        ...d
      };
      await S(b);
    }
  }
}, x = (e) => {
  const { componentDir: t, nameExcludes: n } = e;
  return p.statSync(t).isDirectory() ? p.readdirSync(t).map((c) => {
    const l = u.join(t, c);
    return p.statSync(l).isDirectory() ? (console.log("filePath:", l, u.basename(l)), u.basename(l)) : "";
  }).filter((c) => !(!c || n.includes(c))) : (i.error("组件源码路径不是目录"), process.exit(1));
}, M = async () => {
  i.stage("展示列表");
  const e = h(), t = x(e);
  console.table(
    t.map((n) => {
      const { name: o, fullName: a } = D({
        ...e,
        name: n
      });
      return {
        [$.green("名称")]: o,
        [$.green("带系列名称")]: a,
        [$.green("绝对路径")]: u.resolve(e.componentDir, n)
      };
    })
  );
}, H = {
  command: m.LIST,
  describe: "展示组件列表",
  handler: M
}, U = () => ({
  name: {
    describe: "组件名称",
    type: "string"
  }
}), k = async ({
  name: e
}) => {
  i.stage("添加组件");
  let t;
  e ? t = e : t = (await N({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const n = h();
  K(t, n);
  const { series: o } = n, a = await x(n);
  for (let s of a)
    if (D({
      series: o,
      name: t
    }).nameKebab === s)
      return i.error(`组件${s}已存在, 不能再次创建${t}组件`), process.exit(1);
  return R({
    name: t,
    config: n,
    command: m.ADD
  });
}, W = {
  command: `${m.ADD} <name>`,
  describe: "新增一个组件",
  positionals: U(),
  handler: k
}, Y = () => ({
  name: {
    describe: "组件名称",
    type: "string"
  }
}), A = async ({
  name: e
}) => {
  i.stage("移除组件");
  const t = h(), n = await x(t);
  if (n.length === 0)
    return i.error("组件列表为空"), process.exit(1);
  let o;
  e ? o = e : o = (await N({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: n.map((s) => ({ title: s, value: s }))
  })).name;
  const { series: a } = t;
  for (let s of n)
    if (D({
      series: a,
      name: o
    }).nameKebab === s) {
      await R({
        name: o,
        config: t,
        command: m.REMOVE
      }), p.rmdirSync(u.resolve(t.componentDir, s));
      return;
    }
  return i.error(`组件${o}不存在`), process.exit(1);
}, q = {
  command: `${m.REMOVE} [name]`,
  describe: "删除一个组件",
  positionals: Y(),
  handler: A
}, ce = async (e, t) => {
  switch (e) {
    case m.ADD:
      return k(t);
    case m.REMOVE:
      return A(t);
    case m.LIST:
      return M();
    default:
      throw new Error(`不支持的命令 ${e}`);
  }
}, { version: B, description: G } = g, V = {
  describe: G,
  version: B,
  subcommands: [
    W,
    q,
    H
  ].map(O),
  demandCommandCount: 1,
  rootScriptName: L({ packageJson: g })
}, {
  cliConfig: { moduleName: w }
} = g, j = (e = !1) => {
  const t = e ? w : void 0, n = `$0${e ? ` ${w}` : ""} <command> [options]`;
  return { command: t, usage: n };
}, ie = async () => T({
  ...V,
  ...j()
}), me = () => O({
  ...V,
  ...j(!0)
});
export {
  m as S,
  me as a,
  ie as c,
  ce as h
};
